(function() {
  const fn = function() {
    (function(root) {
      function now() {
        return new Date();
      }
    
      const force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
    
    const element = document.getElementById("bc942647-40fc-4893-a319-12a374f38368");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'bc942647-40fc-4893-a319-12a374f38368' but no matching script tag was found.")
        }
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error(url) {
          console.error("failed to load " + url);
        }
    
        for (let i = 0; i < css_urls.length; i++) {
          const url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error.bind(null, url);
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        for (let i = 0; i < js_urls.length; i++) {
          const url = js_urls[i];
          const element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error.bind(null, url);
          element.async = false;
          element.src = url;
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      const js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.4.3.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-gl-2.4.3.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.4.3.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.4.3.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-mathjax-2.4.3.min.js"];
      const css_urls = [];
    
      const inline_js = [    function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        function(Bokeh) {
          (function() {
            const fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                  const docs_json = '{"b68b5fcc-ee9d-48bc-8490-cfa15994469d":{"defs":[],"roots":{"references":[{"attributes":{"coordinates":null,"formatter":{"id":"1194"},"group":null,"major_label_policy":{"id":"1195"},"ticker":{"id":"1170"}},"id":"1169","type":"LinearAxis"},{"attributes":{"label":{"field":"family"},"renderers":[{"id":"1187"}]},"id":"1199","type":"LegendItem"},{"attributes":{"end_angle":{"expr":{"id":"1181"}},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"white"},"radius":{"value":0.4},"start_angle":{"expr":{"id":"1180"}},"x":{"value":0},"y":{"value":1}},"id":"1184","type":"Wedge"},{"attributes":{},"id":"1191","type":"BasicTickFormatter"},{"attributes":{"coordinates":null,"group":null,"items":[{"id":"1199"}]},"id":"1198","type":"Legend"},{"attributes":{"field":"angle"},"id":"1181","type":"CumSum"},{"attributes":{"data":{"angle":{"__ndarray__":"EjckQaWnxj9lAVs9FOf6Py+w/5iw0vM/9L1I6Zl86T8SNyRBpafGPxI3JEGlp7Y/EjckQaWntj8SNyRBpae2PxI3JEGlp7Y/TSnb8Lv94D9NKdvwu/3QPxI3JEGlp9Y/EjckQaWntj8SNyRBpafGPxI3JEGlp7Y/EjckQaWntj8SNyRBpae2PxI3JEGlp7Y/EjckQaWntj8=","dtype":"float64","order":"little","shape":[19]},"family":["Limacodidae","Noctuidae","Erebidae","Geometridae","Pterophoridae","Tineidae","Blastobasidae","Eriocottidae","Sphingidae","Crambidae","Tortricidae","Nolidae","Psychidae","Thyrididae","Gelechiidae","Oecophoridae","Pyralidae","Lecithoceridae","Notodontidae"],"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18],"value":[2,19,14,9,2,1,1,1,1,6,3,4,1,2,1,1,1,1,1]},"selected":{"id":"1197"},"selection_policy":{"id":"1196"}},"id":"1182","type":"ColumnDataSource"},{"attributes":{},"id":"1174","type":"BasicTicker"},{"attributes":{"callback":null,"tooltips":"@family: @value"},"id":"1177","type":"HoverTool"},{"attributes":{},"id":"1165","type":"LinearScale"},{"attributes":{"source":{"id":"1182"}},"id":"1188","type":"CDSView"},{"attributes":{"below":[{"id":"1169"}],"center":[{"id":"1172"},{"id":"1176"},{"id":"1198"}],"height":350,"left":[{"id":"1173"}],"renderers":[{"id":"1187"}],"title":{"id":"1159"},"toolbar":{"id":"1178"},"toolbar_location":null,"x_range":{"id":"1161"},"x_scale":{"id":"1165"},"y_range":{"id":"1163"},"y_scale":{"id":"1167"}},"id":"1158","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"1196","type":"UnionRenderers"},{"attributes":{"coordinates":null,"group":null,"text":"Pie Chart"},"id":"1159","type":"Title"},{"attributes":{},"id":"1197","type":"Selection"},{"attributes":{"axis":{"id":"1169"},"coordinates":null,"group":null,"ticker":null},"id":"1172","type":"Grid"},{"attributes":{"field":"angle","include_zero":true},"id":"1180","type":"CumSum"},{"attributes":{"axis":{"id":"1173"},"coordinates":null,"dimension":1,"group":null,"ticker":null},"id":"1176","type":"Grid"},{"attributes":{},"id":"1167","type":"LinearScale"},{"attributes":{},"id":"1195","type":"AllLabels"},{"attributes":{"end_angle":{"expr":{"id":"1181"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"hatch_alpha":{"value":0.1},"line_alpha":{"value":0.1},"line_color":{"value":"white"},"radius":{"value":0.4},"start_angle":{"expr":{"id":"1180"}},"x":{"value":0},"y":{"value":1}},"id":"1185","type":"Wedge"},{"attributes":{},"id":"1192","type":"AllLabels"},{"attributes":{"tools":[{"id":"1177"}]},"id":"1178","type":"Toolbar"},{"attributes":{},"id":"1194","type":"BasicTickFormatter"},{"attributes":{"coordinates":null,"data_source":{"id":"1182"},"glyph":{"id":"1184"},"group":null,"hover_glyph":null,"muted_glyph":{"id":"1186"},"nonselection_glyph":{"id":"1185"},"view":{"id":"1188"}},"id":"1187","type":"GlyphRenderer"},{"attributes":{},"id":"1161","type":"DataRange1d"},{"attributes":{"end_angle":{"expr":{"id":"1181"}},"fill_alpha":{"value":0.2},"fill_color":{"value":"#1f77b4"},"hatch_alpha":{"value":0.2},"line_alpha":{"value":0.2},"line_color":{"value":"white"},"radius":{"value":0.4},"start_angle":{"expr":{"id":"1180"}},"x":{"value":0},"y":{"value":1}},"id":"1186","type":"Wedge"},{"attributes":{},"id":"1163","type":"DataRange1d"},{"attributes":{},"id":"1170","type":"BasicTicker"},{"attributes":{"coordinates":null,"formatter":{"id":"1191"},"group":null,"major_label_policy":{"id":"1192"},"ticker":{"id":"1174"}},"id":"1173","type":"LinearAxis"}],"root_ids":["1158"]},"title":"Bokeh Application","version":"2.4.3"}}';
                  const render_items = [{"docid":"b68b5fcc-ee9d-48bc-8490-cfa15994469d","root_ids":["1158"],"roots":{"1158":"bc942647-40fc-4893-a319-12a374f38368"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    let attempts = 0;
                    const timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
    function(Bokeh) {
        }
      ];
    
      function run_inline_js() {
        for (let i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();