(function() {
  const fn = function() {
    (function(root) {
      function now() {
        return new Date();
      }
    
      const force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
    
    const element = document.getElementById("e061a1ad-db08-400e-9985-5287b1e40155");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'e061a1ad-db08-400e-9985-5287b1e40155' but no matching script tag was found.")
        }
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error(url) {
          console.error("failed to load " + url);
        }
    
        for (let i = 0; i < css_urls.length; i++) {
          const url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error.bind(null, url);
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        for (let i = 0; i < js_urls.length; i++) {
          const url = js_urls[i];
          const element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error.bind(null, url);
          element.async = false;
          element.src = url;
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      const js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.4.3.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-gl-2.4.3.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.4.3.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.4.3.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-mathjax-2.4.3.min.js"];
      const css_urls = [];
    
      const inline_js = [    function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        function(Bokeh) {
          (function() {
            const fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                  const docs_json = '{"b142a34e-2eca-4f90-8a7b-d498a87dbb2b":{"defs":[],"roots":{"references":[{"attributes":{"label":{"field":"tribe"},"renderers":[{"id":"1109"}]},"id":"1121","type":"LegendItem"},{"attributes":{},"id":"1083","type":"DataRange1d"},{"attributes":{},"id":"1119","type":"Selection"},{"attributes":{"below":[{"id":"1091"}],"center":[{"id":"1094"},{"id":"1098"},{"id":"1120"}],"height":350,"left":[{"id":"1095"}],"renderers":[{"id":"1109"}],"title":{"id":"1081"},"toolbar":{"id":"1100"},"toolbar_location":null,"x_range":{"id":"1083"},"x_scale":{"id":"1087"},"y_range":{"id":"1085"},"y_scale":{"id":"1089"}},"id":"1080","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"1089","type":"LinearScale"},{"attributes":{"tools":[{"id":"1099"}]},"id":"1100","type":"Toolbar"},{"attributes":{},"id":"1085","type":"DataRange1d"},{"attributes":{},"id":"1117","type":"AllLabels"},{"attributes":{"coordinates":null,"formatter":{"id":"1113"},"group":null,"major_label_policy":{"id":"1114"},"ticker":{"id":"1096"}},"id":"1095","type":"LinearAxis"},{"attributes":{},"id":"1118","type":"UnionRenderers"},{"attributes":{},"id":"1113","type":"BasicTickFormatter"},{"attributes":{"end_angle":{"expr":{"id":"1103"}},"fill_alpha":{"value":0.2},"fill_color":{"value":"#1f77b4"},"hatch_alpha":{"value":0.2},"line_alpha":{"value":0.2},"line_color":{"value":"white"},"radius":{"value":0.4},"start_angle":{"expr":{"id":"1102"}},"x":{"value":0},"y":{"value":1}},"id":"1108","type":"Wedge"},{"attributes":{"coordinates":null,"data_source":{"id":"1104"},"glyph":{"id":"1106"},"group":null,"hover_glyph":null,"muted_glyph":{"id":"1108"},"nonselection_glyph":{"id":"1107"},"view":{"id":"1110"}},"id":"1109","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"1095"},"coordinates":null,"dimension":1,"group":null,"ticker":null},"id":"1098","type":"Grid"},{"attributes":{"end_angle":{"expr":{"id":"1103"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"hatch_alpha":{"value":0.1},"line_alpha":{"value":0.1},"line_color":{"value":"white"},"radius":{"value":0.4},"start_angle":{"expr":{"id":"1102"}},"x":{"value":0},"y":{"value":1}},"id":"1107","type":"Wedge"},{"attributes":{"end_angle":{"expr":{"id":"1103"}},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"white"},"radius":{"value":0.4},"start_angle":{"expr":{"id":"1102"}},"x":{"value":0},"y":{"value":1}},"id":"1106","type":"Wedge"},{"attributes":{"coordinates":null,"group":null,"text":"Pie Chart"},"id":"1081","type":"Title"},{"attributes":{"field":"angle"},"id":"1103","type":"CumSum"},{"attributes":{},"id":"1087","type":"LinearScale"},{"attributes":{},"id":"1114","type":"AllLabels"},{"attributes":{},"id":"1092","type":"BasicTicker"},{"attributes":{"source":{"id":"1104"}},"id":"1110","type":"CDSView"},{"attributes":{"coordinates":null,"formatter":{"id":"1116"},"group":null,"major_label_policy":{"id":"1117"},"ticker":{"id":"1092"}},"id":"1091","type":"LinearAxis"},{"attributes":{"field":"angle","include_zero":true},"id":"1102","type":"CumSum"},{"attributes":{"callback":null,"tooltips":"@tribe: @value"},"id":"1099","type":"HoverTool"},{"attributes":{"axis":{"id":"1091"},"coordinates":null,"group":null,"ticker":null},"id":"1094","type":"Grid"},{"attributes":{},"id":"1116","type":"BasicTickFormatter"},{"attributes":{"data":{"angle":{"__ndarray__":"c05w+q4Ssj9zTnD6rhLCP6x1qHcGHMs/c05w+q4S0j/ea1qYsNn4P3NOcPquEuI/c05w+q4S0j+sdah3BhzLP3NOcPquEtI/EGIMuVqX1j8QYgy5WpfWP3NOcPquErI/c05w+q4Swj9zTnD6rhLCP3NOcPquErI/rHWodwYcyz9zTnD6rhKyP3NOcPquErI/c05w+q4Ssj9zTnD6rhLiP3NOcPquErI/c05w+q4Swj9zTnD6rhLCP3NOcPquErI/c05w+q4Ssj9zTnD6rhKyPw==","dtype":"float64","order":"little","shape":[26]},"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25],"tribe":["Nolini","Boletobiini","Hemitheini","Macariini","Boarmiini","Eupitheciini","Crambini","Argyrogrammatini","Platyptiliini","Archipini","Phycitini","Pyralini","Arctiini","Syntomini","Olethreutini","Cosymbiini","Nomophilini","Caberini","Poaphilini","Orgyiini","Oidaematophorini","Eucosmini","Pyraustini","Sarrothripini","Noctuini","Grapholitini"],"value":[1,2,3,4,22,8,4,3,4,5,5,1,2,2,1,3,1,1,1,8,1,2,2,1,1,1]},"selected":{"id":"1119"},"selection_policy":{"id":"1118"}},"id":"1104","type":"ColumnDataSource"},{"attributes":{"coordinates":null,"group":null,"items":[{"id":"1121"}]},"id":"1120","type":"Legend"},{"attributes":{},"id":"1096","type":"BasicTicker"}],"root_ids":["1080"]},"title":"Bokeh Application","version":"2.4.3"}}';
                  const render_items = [{"docid":"b142a34e-2eca-4f90-8a7b-d498a87dbb2b","root_ids":["1080"],"roots":{"1080":"e061a1ad-db08-400e-9985-5287b1e40155"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    let attempts = 0;
                    const timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
    function(Bokeh) {
        }
      ];
    
      function run_inline_js() {
        for (let i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();